//
//  Calculator.m
//  ロト6補助
//
//  Created by Killery on 2013/12/31.
//  Copyright (c) 2013年 Killery. All rights reserved.
//

#import "Calculator.h"

@implementation Calculator

-(void)awakeFromNib{

    [trial setStringValue:[NSString stringWithFormat:@"%d%@", 1, trialStr]];
    [errMessage setHidden:YES];
    resultMA = [NSMutableArray new];
}

-(id)init{

    trialStr = @"番目の組み合わせ";
    trialNum = 1;
    
    return self;
}

-(IBAction)submit:(id)sender{
    char result;
    bool succeed = false;
    result = [self submitData];
    switch (result) {
        case R_COMP:
            succeed = true;
            [errMessage setHidden:YES];
            break;
        case R_ERR_OVERTRIAL:
            [errMessage setStringValue:@"※手入力の数字が6個を超えています"];
            [errMessage setHidden:NO];
            break;
        case R_ERR_OVERNUM_T:
            [errMessage setStringValue:@"※手入力の数字が43を超えています"];
            [errMessage setHidden:NO];
            break;
        case R_ERR_SAMENUM_T:
            [errMessage setStringValue:@"※手入力の数字に同じ数字があります"];
            [errMessage setHidden:NO];
            break;
        case R_ERR_OVERNUM_H:
            [errMessage setStringValue:@"※高確率の数字が43を超えています"];
            [errMessage setHidden:NO];
            break;
        case R_ERR_OVERNUM_L:
            [errMessage setStringValue:@"※絶対出ないの数字が43を超えています"];
            [errMessage setHidden:NO];
            break;
        default:
            break;
    }
    
    if(succeed){
        
        for(int i = 0;i < 5;i++){
            for(int k = 5;k > i;k--){
                if(data.result[k - 1] > data.result[k]){
                    int tmp = data.result[k];
                    data.result[k] = data.result[k-1];
                    data.result[k-1] = tmp;
                }
            }
        
        }
        
        
        NSMutableDictionary* dict = [NSMutableDictionary new];
        [dict setValue:[NSString stringWithFormat:@"%02d  %02d  %02d  %02d  %02d  %02d",
                        data.result[0], data.result[1], data.result[2],
                        data.result[3], data.result[4], data.result[5]] forKey:@"value"];
        
        [self willChangeValueForKey:@"resultMA"];
        [resultMA addObject:dict];
        [self didChangeValueForKey:@"resultMA"];
    
        trialNum++;
        [trial setStringValue:[NSString stringWithFormat:@"%d%@", trialNum, trialStr]];
    }
}

-(IBAction)reset:(id)sender{
    [self willChangeValueForKey:@"resultMA"];
    [resultMA removeAllObjects];
    [self didChangeValueForKey:@"resultMA"];
    
    trialNum = 1;
    [trial setStringValue:[NSString stringWithFormat:@"%d%@", trialNum, trialStr]];
}


-(char)submitData{

    NSString *str1 = [input stringValue];
    NSString *str2 = [highRate stringValue];
    NSString *str3 = [lowRate stringValue];
    NSArray *array1 = [str1 componentsSeparatedByString:@" "];
    NSArray *array2 = [str2 componentsSeparatedByString:@" "];
    NSArray *array3 = [str3 componentsSeparatedByString:@" "];
    
    for(int i = 0;i<6;i++){
        data.num[i] = 0;
        data.result[i] = 0;
    }
    
    
    for(int i = 0;i < [array1 count];i++){
        int arrayVal = [[array1 objectAtIndex:i] intValue];
        
        if(i >= 6)
            return R_ERR_OVERTRIAL;
        if(arrayVal > 43)
            return R_ERR_OVERNUM_T;
        if(arrayVal <= 0)
            break;
        for(int k = 0;k < i;k++){
            if(arrayVal == data.num[k])
                return R_ERR_SAMENUM_T;
        }
        
        data.num[i] = arrayVal;
    }
    
    for (int i = 0;i < [array2 count];i++) {
        int arrayVal = [[array2 objectAtIndex:i] intValue];
        
        if(arrayVal > 43)
            return R_ERR_OVERNUM_H;
        
        if(i == 0)
            data.high = (int*)malloc(sizeof(int)*[array2 count]);
        *(data.high + i) = arrayVal;
    }
    
    for (int i = 0;i < [array3 count];i++) {
        int arrayVal = [[array3 objectAtIndex:i] intValue];
        
        if(arrayVal > 43)
            return R_ERR_OVERNUM_L;
        
        if(i == 0)
            data.low = (int*)malloc(sizeof(int)*[array3 count]);
        *(data.low + i) = arrayVal;
    }
    
    
    for (int i = 0; i < 6 && data.num[i] > 0;i++) {
        data.result[i] = data.num[i];
    }
    
    for (int i = 0; i < 6;i++) {
        if(data.result[i] > 0)
            continue;
        
        bool loopEnd = false;
        int val;
        int elect = (int)[highRateSlct indexOfSelectedItem];
        int electNum = 0;
        bool electedFlag = false;
        while (!loopEnd) {
            bool flag = true;
            bool electedFlag = false;
            val = rand()%43 + 1;

            int prolly = rand()%100+1;
            if(prolly >= 70 && electNum < elect){
                    int random = rand()%[array2 count];
                    val = *(data.high + random);
                    electedFlag = true;
            }
            
            for(int k = 0; k < i;k++) {
                if(data.result[k] == val)
                    flag = false;
            }
            for (int k = 0;k < [array3 count];k++) {
                if(*(data.low + k) == val)
                    flag = false;
            }
            if(flag)
                loopEnd = true;
        }
        if(electedFlag){
            electNum++;
            electedFlag = false;
        }
        data.result[i] = val;
    }
    
    
    return R_COMP;
}















@end
















